*//	CreateSampleData.prg
*//	
*//	Program to create sample data for simple 
*//	database. The database structure is:
*//	
*//	Field		Type	Example
*//	----------  ------  --------------
*//	AC_ID		I		1,2,3,4...
*//	AC_ACCOUNT	C(10)	'012-004773'
*//	AC_NAME		C(25)	'Smythe','Goethe'
*//	AC_BALANCE	Y		$0.00
*//	AC_DOB		D		13/04/1957
*//	AC_INACTIV	L		.T., .F.
*//	AC_NOTES	M		'yaday yada'
*//	----------  ------  --------------

#define RECORD_COUNT	500

*//		Initialise the random number generator:

rand(-1)
close data

*//		Create the bank dbc:

create database sample

*//		Create the id master table:	

create table uniqueid ( ENTITY c(8), ID i )
insert into uniqueid values ( 'account', RECORD_COUNT+1 )

*//		Create the account table:	

select 0
create table account ( ;
	AC_ID i, ;
	AC_ACCOUNT c(10), ;
	AC_NAME c(25), ;
	AC_BALANCE y, ;
	AC_DOB d, ;
	AC_INACTIV l, ;
	AC_NOTES m )
index on ac_id tag ac_id
index on ac_account tag ac_account
index on upper(ac_name) tag uac_name
index on ac_inactiv tag ac_inactiv

*//		Create some dummy data:

for i = 1 to RECORD_COUNT
	insert into account ( ;
		AC_ID, ;
		AC_ACCOUNT, ;
		AC_NAME, ;
		AC_BALANCE, ;
		AC_DOB, ;
		AC_INACTIV ) ;
	values ( ;
		m.i, ;
		'012-040' + trans(RECORD_COUNT-m.i), ;
		GetRandomName(), ;
		rand()*10000, ;
		{^1950-01-01} + int(rand()*40*365), ;
		(mod(m.i,13)=0) )
endfor
return

*//		Silly random name generator:

function GetRandomName
	#define LETTERS 'ABECIDOEFUGAHEIJOKULAMENIOPUARESITOUVAWEIYO_'
	local cName, i
	cName = ""
	for i = 1 to 6	      
		cName = m.cName + ;
			substr( LETTERS, 1+rand()*(len(LETTERS)-1), 1)
	endfor
	cName = cName ;
		  +	', ' + substr( LETTERS, 1+rand()*(len(LETTERS)-1), 1) ;
	      + ' ' + substr( LETTERS, 1+rand()*(len(LETTERS)-1), 1) 
	return Proper(m.cName)
endfunc